//
//  PlayerViewController.swift
//  AmpChromecastSample
//
//  Created by Lopez Valenciano, Miguel on 11/10/17.
//  Copyright © 2017 Akamai. All rights reserved.
//

import UIKit
import AmpCore
import AmpChromecast
import GoogleCast

//let url = "https://commondatastorage.googleapis.com/gtv-videos-bucket/CastVideos/mp4/DesigningForGoogleCast.mp4"
let url = "https://commondatastorage.googleapis.com/gtv-videos-bucket/CastVideos/hls/Sintel.m3u8"

class PlayerViewController: UIViewController {
    
    @IBOutlet weak var playerView: UIView!
    var ampPlayer: AmpPlayer?
    var ampChromecast: AmpChromecastManager?
    
    open var videoId:Video?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.ampPlayer = AmpPlayer(parentView: self.playerView)
        self.ampPlayer?.setLicense("AwH4ufhrEyYgvu5dFMNtHJntZpWMB9CA6Gb4sSAn5s2t9cLPSBgV5T5nUAtsOtH7K23SS4F2Tlxu5Bz5GJHxWZD6DIhLcbc+RdBk+75LFL2/twdH9vhGBAQsEWohZVxjfJq5TOY20EcWU3A3cQly1pDU7ENCdE6A+UzrQASsVPSOGbjcHD3v2QLRMVK1tjBpBHv7Efh+dSNFWKsSLfNhZlRI6664Al+Jr9TuzjwyrloZcPxfDXznkPXNIqxyRkmAyT4=")
        self.ampPlayer?.autoplay = true
        self.ampPlayer?.registerObserver(self)
        self.ampChromecast = AmpChromecastManager(ampPlayer: self.ampPlayer!, parentViewController: self)
        self.ampChromecast?.mediaInfo = videoId?.mediaItem
        self.ampChromecast?.registerObserver(self)
        self.ampPlayer?.handleUrl(videoId!.url)
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
    override open func viewWillDisappear(_ animated:Bool) {
        if (self.isMovingFromParentViewController) {
            self.ampPlayer?.stop()
            self.ampPlayer = nil
            print("Stopped")
        }
        super.viewWillDisappear(animated)
    }
    
    
}

extension PlayerViewController : PlayerEventObserver {
    
    func onCuepointReached(_ ampPlayer: AmpPlayer, atTime: Double) {
        AmpLogger.info("Cuepoint at \(atTime)")
    }
    
    func onExitFullscreen(_ ampPlayer: AmpPlayer) {
        print("onExitFullscreen")
    }
}

extension PlayerViewController : AmpChromecastObserver {
    
    func onChromecastPlaybackStateChanged(_ manager: AmpChromecastManager) {
        print("onChromecastPlaybackStateChanged")
    }
    
    func onChromecastError(_ manager: AmpChromecastManager, error: Error?) {
        print("onChromecastError \(error)")
    }
    
}
