//
//  ViewController.swift
//  AmpChromecastSample
//
//  Created by Lopez Valenciano, Miguel on 5/5/16.
//  Copyright © 2016 Akamai. All rights reserved.
//

import UIKit
import AmpChromecast
import GoogleCast

class ViewController: UIViewController {
    
    @IBOutlet weak var tableView: UITableView!
    var videoArray = [Video]()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.parseVideos()
    }
    
    func parseVideos() {
        var metadata = GCKMediaMetadata(metadataType: .movie)
        metadata.setString("Sintel", forKey: kGCKMetadataKeyTitle)
        metadata.addImage(GCKImage(url:URL(string: "https://img00.deviantart.net/18af/i/2010/270/1/6/i_love_sintel_by_nash88-d2zkxw5.jpg")!, width: 480, height: 720))
        metadata.setString("Sintiel Video", forKey: "description")
        
        var mediaInfo = GCKMediaInformation(contentID: url, streamType: .buffered, contentType: "application/x-mpegURL", metadata: metadata, streamDuration: TimeInterval(100), customData: nil)
        
        var mediaItem = MediaItem(mediaInformation: mediaInfo)
        
        var video = Video(url: url, mediaItem: mediaItem)
        
        videoArray.append(video)
        
        metadata = GCKMediaMetadata(metadataType: .movie)
        metadata.setString("Beach", forKey: kGCKMetadataKeyTitle)
        metadata.addImage(GCKImage(url:URL(string: "https://vacationidea.com/pix/img25Hy8R/beaches/best-beaches-in-costa-rica_f.jpg")!, width: 480, height: 720))
        metadata.setString("Beach Sample", forKey: "description")
        
        mediaInfo = GCKMediaInformation(contentID: "https://mnmedias.api.telequebec.tv/m3u8/29880.m3u8", streamType: .buffered, contentType: "application/x-mpegURL", metadata: metadata, streamDuration: TimeInterval(180), customData: nil)
        
        mediaItem = MediaItem(mediaInformation: mediaInfo)
        
        video = Video(url: "https://mnmedias.api.telequebec.tv/m3u8/29880.m3u8", mediaItem: mediaItem)
        
        videoArray.append(video)
        
        
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        let index = self.tableView.indexPathForSelectedRow!
        let destinationViewController = segue.destination as! PlayerViewController
        destinationViewController.videoId = self.videoArray[index.row]
    }
    
}

extension ViewController: UITableViewDelegate {
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        tableView.deselectRow(at: indexPath, animated: true)
    }
}

extension ViewController:UITableViewDataSource {
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 2
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "cell", for: indexPath) as UITableViewCell
        
        cell.textLabel?.text = "Video \(indexPath.row + 1)"
        
        return cell
        
    }
}
